int clk = 7;
int load = 6;
int din = 5;

int interval = 200;

byte hours = 0;
byte hoursTens = 0;
byte hoursOnes = 0;
byte minutesTens = 0;
byte minutesOnes = 0;
byte secondsTens = 0;
byte secondsOnes = 0;

//hoursTens
byte zero100[20] = {1, 0, 0, 0, 0, 0,
                    1,//A
                    1,//B
                    1,//C
                    1,//D
                    0,//E
                    1,//F
                    0,//G
                    0, 0, 0, 0, 0, 0, 1
                   };

byte one100[20] = {1, 0, 0, 0, 0, 0,
                   0,//A
                   1,//B
                   1,//C
                   0,//D
                   0,//E
                   0,//F
                   0,//G
                   0, 0, 0, 0, 0, 0, 0
                  };

byte two100[20] = {1, 0, 0, 0, 0, 0,
                   1,//A
                   1,//B
                   0,//C
                   1,//D
                   0,//E
                   0,//F
                   1,//G
                   0, 0, 0, 0, 0, 0, 1
                  };

byte three100[20] = {1, 0, 0, 0, 0, 0,
                     1,//A
                     1,//B
                     1,//C
                     1,//D
                     0,//E
                     0,//F
                     1,//G
                     0, 0, 0, 0, 0, 0, 0
                    };

byte four100[20] = {1, 0, 0, 0, 0, 0,
                    0,//A
                    1,//B
                    1,//C
                    0,//D
                    0,//E
                    1,//F
                    1,//G
                    0, 0, 0, 0, 0, 0, 0
                   };

byte five100[20] = {1, 0, 0, 0, 0, 0,
                    1,//A
                    0,//B
                    1,//C
                    1,//D
                    0,//E
                    1,//F
                    1,//G
                    0, 0, 0, 0, 0, 0, 0
                   };

byte six100[20] = {1, 0, 0, 0, 0, 0,
                   1,//A
                   0,//B
                   1,//C
                   1,//D
                   0,//E
                   1,//F
                   1,//G
                   0, 0, 0, 0, 0, 0, 1
                  };

byte seven100[20] = {1, 0, 0, 0, 0, 0,
                     1,//A
                     1,//B
                     1,//C
                     0,//D
                     0,//E
                     0,//F
                     0,//G
                     0, 0, 0, 0, 0, 0, 0
                    };

byte eight100[20] = {1, 0, 0, 0, 0, 0,
                     1,//A
                     1,//B
                     1,//C
                     1,//D
                     0,//E
                     1,//F
                     1,//G
                     0, 0, 0, 0, 0, 0, 1
                    };

byte nine100[20] = {1, 0, 0, 0, 0, 0,
                    1,//A
                    1,//B
                    1,//C
                    1,//D
                    0,//E
                    1,//F
                    1,//G
                    0, 0, 0, 0, 0, 0, 0
                   };

//hoursOnes
byte zero10[20] = {0, 1, 0, 0, 0, 0,
                   1,//A
                   1,//B
                   1,//C
                   1,//D
                   0,//E
                   1,//F
                   0,//G
                   0, 0, 0, 0, 0, 0, 1
                  };

byte one10[20] = {0, 1, 0, 0, 0, 0,
                  0,//A
                  1,//B
                  1,//C
                  0,//D
                  0,//E
                  0,//F
                  0,//G
                  0, 0, 0, 0, 0, 0, 0
                 };

byte two10[20] = {0, 1, 0, 0, 0, 0,
                  1,//A
                  1,//B
                  0,//C
                  1,//D
                  0,//E
                  0,//F
                  1,//G
                  0, 0, 0, 0, 0, 0, 1
                 };

byte three10[20] = {0, 1, 0, 0, 0, 0,
                    1,//A
                    1,//B
                    1,//C
                    1,//D
                    0,//E
                    0,//F
                    1,//G
                    0, 0, 0, 0, 0, 0, 0
                   };

byte four10[20] = {0, 1, 0, 0, 0, 0,
                   0,//A
                   1,//B
                   1,//C
                   0,//D
                   0,//E
                   1,//F
                   1,//G
                   0, 0, 0, 0, 0, 0, 0
                  };

byte five10[20] = {0, 1, 0, 0, 0, 0,
                   1,//A
                   0,//B
                   1,//C
                   1,//D
                   0,//E
                   1,//F
                   1,//G
                   0, 0, 0, 0, 0, 0, 0
                  };

byte six10[20] = {0, 1, 0, 0, 0, 0,
                  1,//A
                  0,//B
                  1,//C
                  1,//D
                  0,//E
                  1,//F
                  1,//G
                  0, 0, 0, 0, 0, 0, 1
                 };

byte seven10[20] = {0, 1, 0, 0, 0, 0,
                    1,//A
                    1,//B
                    1,//C
                    0,//D
                    0,//E
                    0,//F
                    0,//G
                    0, 0, 0, 0, 0, 0, 0
                   };

byte eight10[20] = {0, 1, 0, 0, 0, 0,
                    1,//A
                    1,//B
                    1,//C
                    1,//D
                    0,//E
                    1,//F
                    1,//G
                    0, 0, 0, 0, 0, 0, 1
                   };

byte nine10[20] = {0, 1, 0, 0, 0, 0,
                   1,//A
                   1,//B
                   1,//C
                   1,//D
                   0,//E
                   1,//F
                   1,//G
                   0, 0, 0, 0, 0, 0, 0
                  };
void setup() {
  pinMode(din, OUTPUT);
  pinMode(load, OUTPUT);
  pinMode(clk, OUTPUT);

  digitalWrite(clk, LOW);
  digitalWrite(load, LOW);
  digitalWrite(din, LOW);

  //Serial.begin(9600);
}

void loop() {

  hours++;
  if (hours > 99) {
    hours = 0;
  }

  hoursTens = (hours) / 10;
  hoursOnes = (hours) % 10;

  for (byte j = 0; j < interval; j++) {


    //HOURS
    if (hoursTens == 0) shiftDigit(0, zero100);
    if (hoursTens == 1) shiftDigit(0, one100);
    if (hoursTens == 2) shiftDigit(0, two100);
    if (hoursTens == 3) shiftDigit(0, three100);
    if (hoursTens == 4) shiftDigit(0, four100);
    if (hoursTens == 5) shiftDigit(0, five100);
    if (hoursTens == 6) shiftDigit(0, six100);
    if (hoursTens == 7) shiftDigit(0, seven100);
    if (hoursTens == 8) shiftDigit(0, eight100);
    if (hoursTens == 9) shiftDigit(0, nine100);

    if (hoursOnes == 0) shiftDigit(1, zero10);
    if (hoursOnes == 1) shiftDigit(1, one10);
    if (hoursOnes == 2) shiftDigit(1, two10);
    if (hoursOnes == 3) shiftDigit(1, three10);
    if (hoursOnes == 4) shiftDigit(1, four10);
    if (hoursOnes == 5) shiftDigit(1, five10);
    if (hoursOnes == 6) shiftDigit(1, six10);
    if (hoursOnes == 7) shiftDigit(1, seven10);
    if (hoursOnes == 8) shiftDigit(1, eight10);
    if (hoursOnes == 9) shiftDigit(1, nine10);
  }

  delay(500);
}



void shiftDigit (byte pozitie, byte caracter[20]) {
  // first put position of character
  for (int i = 0; i < 20; i++) {
    if (i == pozitie) digitalWrite(din, 1);
    else  digitalWrite(din, 0);
    digitalWrite(clk, HIGH);
    digitalWrite(clk, LOW);
  }
  digitalWrite(clk, LOW);

  // second put letter/character
  for (int i = 19; i >= 0; i--) {
    digitalWrite(din, caracter[i]);
    digitalWrite(clk, HIGH);
    digitalWrite(clk, LOW);
  }
  digitalWrite(clk, LOW);

  // load the changes
  digitalWrite(load, HIGH);
  digitalWrite(load, LOW);
}
